﻿using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Robware.Auth.API;

namespace Robware.Api.Auth.Controllers {
	[ApiController]
	[Route("[controller]")]
	public class ApiController : ControllerBase {
		private readonly ILogger<ApiController> _logger;
		private readonly IApiKeyValidator _apiKeyValidator;

		public ApiController(ILogger<ApiController> logger, IApiKeyValidator apiKeyValidator) {
			_logger = logger;
			_apiKeyValidator = apiKeyValidator;
		}

		[HttpGet(nameof(Validate))]
		public async Task<ActionResult> Validate(string key) => await _apiKeyValidator.Validate(key) ? (ActionResult) Ok() : Unauthorized();
	}
}
