﻿using System.Linq;
using System.Threading.Tasks;
using Dapper;
using Robware.Auth.Users;
using Robware.Data.Users.States;

namespace Robware.Data.Users {
	public class UserRepository : IUsers {
		private readonly IDatabaseProvider _dbProvider;

		public UserRepository(IDatabaseProvider dbProvider) {
			_dbProvider = dbProvider;
		}

		public async Task<User> GetByEmail(string email) {
			const string query = "SELECT * FROM users WHERE user_email=@email";

			using (var connection = _dbProvider.NewConnection()) {
				connection.Open();
				var result = await connection.QueryAsync<UserState>(query, new { email });

				if (!result.Any())
					throw new UserNotFoundException(email);

				return new DatabaseUser(result.Single());
			}
		}
	}
}